//Fortran: EQUIVALENCE ( ... )
Unit ZP12C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, GSU2R_p, ZP12C1_p, ZP12C2_p, ZP12C3_p, ZP12C4_p, ZP12C5_p;

procedure ZP12C(var NP :Integer; var A :Array of Real;
                var D :Array of Real; var B :Array of Real;
                var IERR :Integer);

implementation

procedure ZP12C(var NP :Integer; var A :Array of Real;
                var D :Array of Real; var B :Array of Real;
                var IERR :Integer);
var
I,IC,IC1,IC2,ICB,IG,IJ,ISE,ITS,J,J1,J2,J3,KIER,KIP,L,LN,M,N,N1,N2,NP0,
   NQ :Integer;
BMIN,CN,E,E0,E1,EC,ED,EE,EN,EPS,FE,FEA,FI,R,R0,RK,RKA,R1,SUM,TK,V,
   WMAX,Y,Z2Q :Real;
FC :Complex;
F :Array [0..1] of Real;
//F :Array [0..1] of Extended;
ROOT :Array [0..1] of Real;
S :Array [0..1] of Real;
Z0 :Array [0..1] of Real;
Z1 :Array [0..1] of Real;
Z2 :Array [0..1] of Real;
ZC :Array [0..1] of Real;
const
SYS051 :Real = 1.192093E-07;
SYS053 :Real = 1.7E308;  //  Delphi>3
SYS056 :Real = 1.2E-38;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400;
begin
{ **********************************************************C }
{ ----------------------HAHAEHE--------------------------C }
{                                                           C }
{    OPEEEHE BCEX KOPHE OHOMA C KOMEKCHM        C }
{    KOEHTAM METOOM HACKOPEEO CYCKA.           C }
{                                                           C }
{    TEPATYPA:                                            C }
{    BOEBOH B.B.ABEHKO O.A. MOPOBAHH METO      C }
{    HACKOPEEO CYCKA  OPEEEH BCEX KOPHE       C }
{    OHOMA,C."CEHH AHA HA OPTPAHE",B.27.     C }
{    -MY,1980.                                             C }
{                                                           C }
{ --------------------COOBAHE-------------------------C }
{                                                           C }
{        CALL ZP12C(N,A,D,B,IERR)                           C }
{                                                           C }
{ ----------------------APAMETP---------------------------C }
{                                                           C }
{    A - OHOMEPH MACCB H (N+1), COEPA          C }
{        KOEHT OHOMA,AAHHE B OPKE BOPACT.  C }
{        CTEEHE APYMEHTA (A(1)  A(N+1) HE PABH (0.,0.))C }
{        (T: COMPLEX);                                    C }
{                                                           C }
{    D - OHOMEPH PAO MACCB H (N+1)              C }
{        (T: COMPLEX);                                    C }
{                                                           C }
{    N - CTEEH OHOMA (T: INTEGER);                   C }
{                                                           C }
{    B - OHOMEPH MACCB H (N+1),COEPA HA BXOE C }
{        B EPBX N EMEHTAX BCEHHE KOPH OHOMA    C }
{        (T: COMPLEX).                                    C }
{                                                           C }
{ ----------------BBAEME OPOPAMM-------------------C }
{                                                           C }
{            ABS,SIN,COS;                                   C }
{        ZP12C1,ZP12C2,ZP12C3,ZP12C4,ZP12C5,GSU2R           C }
{                                                           C }
{ ----------------------KOHCTAHT---------------------------C }
{                                                           C }
{    WMAX=9.2233723684E18                                  C }
{                                                           C }
{ **********************************************************C }
ZP12C2(A,NP + 1);
NP0  := NP;
ZP12C5(A,NP,B,IERR,KIER);
if ( IERR  >=  67 )
 then goto _350;
M  := 5;
WMAX  := SYS053;
ISE  := 1979;
L  := 2*NP + 2;
LN  := L;
N  := NP;
N1  := N;
{   EPEMEHHE IC(ICB) PABH 1  -1,EC KOEHT     C }
{   TEKYEO(XPAHMOO) OHOMA OTHOCTC,COOTBETCTBEHHO,  C }
{   K PMM  OPATHM EPEMEHHM.                       C }
IC  := 1;
ICB  := 1;
for I:=1 to L do
 begin
  B[I-1] := A[I-1];
_10:
 end;
{   OEPEHO KOPEH.                                       C }
_20:
{   OCET FE-OEHK OOK OKPYEH B  CXEME OPHEPA    C }
{   P BCEH HAEH OHOMA                        C }
{    BMIN - HAMEHEO MOY  KOEHTOB.             C }
SUM  := 0.0;
BMIN  := ZP12C3(B[0]);
V  := ZP12C3(B[2*N+0]);
if ( BMIN  >  V )
 then BMIN  := V;
for I:=1 to LN do
 begin
  V  := Abs(B[I-1]);
  SUM  := SUM + V;
_30:
 end;
NQ  := N*N;
if ( SUM  <=  WMAX/NQ ) 
 then goto _50;
{   HOPMPOBKA KOEHTOB,OCTATOHA  EAH      C }
{   EPEOHEH B CXEME OPHEPA.                           C }
for I:=1 to LN do
 begin
  B[I-1] := B[I-1]/NQ;
_40:
 end;
SUM  := SUM/NQ;
BMIN  := BMIN/NQ;
_50:
FE  := (2*N)*SUM*SYS051;
if ( BMIN  <  FE ) 
 then FE  := BMIN;
{   BCEHE RK=(B(1)/B(N))**1./N-CPEHEO EOMETPECKOOC }
{   PACCTOH OT 0 O KOPHE OHOMA B. EC RK>1,        C }
{   TO EPEXO K OPATHM EPEMEHHM.                       C }
E  := ZP12C3(B);
EN  := ZP12C3(B[2*N+0]);
CN  := 1.0/(N);
if ( EN  >  E ) 
 then goto _60;
RK  := Power(EN,CN)/Power(E,CN);
goto _70;
_60:
RK  := Power(E,CN)/Power(EN,CN);
ZP12C2(B,N + 1);
IC  := -IC;
_70:
if ( N  <  NP ) 
 then goto _80;
FEA  := FE;
RKA  := RK;
{  BC.CYAHO TOK BHYTP KOA PAYCOB: 1.3  RK. }
_80:
Y  := GSU2R(ISE);
Z1[0] := RK + Y*(1.003 - RK);
Z1[1] := Z1[0];
Y  := 6.29*GSU2R(ISE);
Z1[0] := Z1[0]*Sin(Y);
Z1[1] := Z1[1]*Cos(Y);
_90:
R  := 2.0;
ZP12C1(B,D,N,Z1);
E  := ZP12C3(D[2*N+0]);
_100:
{  HAAO METOA HACKOPEEO CYCKA: }
ZP12C1(D,D,N - 1,Z1);
E1  := ZP12C3(D[2*N-2]);
{   KPTEP OKOHAH METOA CYCKA-MOY OHOMA MEHE C }
{   OKPYEH.                                             C }
if ( E  >=  FE ) 
 then goto _110;
if ( E1  <=  E/WMAX ) 
 then goto _210;
FC  := ZP12C4(D[2*N+0],D[2*N-2]);
F[0] := FC.re;  //  EQUIVALENCE
F[1] := FC.im;  //  EQUIVALENCE
R  := ZP12C3(F);
goto _180;
_110:
if ( E  >  (M)*(1.0 + RK)*E1 ) 
 then goto _80;
{   EC Z1-KA K CEOBO,TO EPEXO K HOBO CY.TOKE C }
{    TOK Z1 O BCEHHOMY HAPABEH -F C YBAM  C }
{   AOM TK=1,.5,.25,...  HAXOTC TOK Z2 O TEX OP,   C }
{   OKA HE CTAHET IP(Z2)I<IP(Z1)I.                         C }
{  I-CO PO }
I  := 1;
TK  := 1.0;
FC  := ZP12C4(D[2*N+0],D[2*N-2]);
F[0] := FC.re;  //  EQUIVALENCE
F[1] := FC.im;  //  EQUIVALENCE
IC1  := 1;
_120:
Z2[0] := Z1[0] - TK*F[0];
Z2[1] := Z1[1] - TK*F[1];
{   EC IZ2I>1.3, TO EPEXO K OPATHM EPEMEHHM.       C }
Z2Q  := IntPower(Z2[0],2) + IntPower(Z2[1],2);
IC2  := 1;
if ( Z2Q  >  1.003 ) 
 then IC2  := -1;
if ( IC2  =  IC1 ) 
 then goto _130;
ZP12C2(B,N + 1);
_130:
if ( IC2  =  1 ) 
 then goto _140;
Z2[0] := Z2[0]/Z2Q;
Z2[1] := -Z2[1]/Z2Q;
_140:
ZP12C1(B,D,N,Z2);
IC1  := IC2;
ED  := ZP12C3(D[2*N+0]);
if ( E  >  ED ) 
 then goto _160;
I  := I + 1;
if ( I  <  10 ) 
 then goto _150;
if ( IC1  =  -1 ) 
 then ZP12C2(B,N + 1);
if ( N  <  NP ) 
 then goto _80;
goto _210;
_150:
TK  := TK/2.0;
goto _120;
_160:
if ( IC1  =  1 ) 
 then goto _170;
IC  := -IC;
RK  := 1.0/RK;
_170:
Z1[0] := Z2[0];
Z1[1] := Z2[1];
E  := ED;
{  Z1-OEPEHA TOKA CYCKA.                              C }
goto _100;
_180:
R0  := R;
E0  := E;
IJ  := 0;
_190:
TK  := 0.0;
IJ  := IJ + 1;
_200:
TK  := TK + 1;
ZC[0] := Z1[0] - TK*F[0];
ZC[1] := Z1[1] - TK*F[1];
ZP12C1(B,D,N,ZC);
EE  := ZP12C3(D[2*N+0]);
if ( EE  <  E ) 
 then goto _200;
if ( TK  =  1.0 ) 
 then goto _210;
ITS  := Trunc( TK/2.0 );
Z1[0] := Z1[0] - ITS*F[0];
Z1[1] := Z1[1] - ITS*F[1];
R0  := ZP12C3(F)*ITS;
if ( IJ  >=  10 ) 
 then goto _210;
ZP12C1(B,D,N,Z1);
EC  := ZP12C3(D[2*N+0]);
E0  := EC;
ZP12C1(D,D,N - 1,Z1);
E1  := ZP12C3(D[2*N-2]);
if ( EC  >=  E1*2.0 ) 
 then goto _210;
FC  := ZP12C4(D[2*N+0],D[2*N-2]);
F[0] := FC.re;  //  EQUIVALENCE
F[1] := FC.im;  //  EQUIVALENCE
E  := EC;
goto _190;
_210:
{    YCT Z-KOPEH P(Z) KPATHOCT K,TOA Z-KOPEH EPBX C }
{    (K-1)-HO POBOHX P(Z). OH A METOA HTOHA   C }
{    PMEHETC  POBOHX P(Z)  TOK Z1.         C }
if ( R  =  0.0 ) 
 then R  := ZP12C3(F);
Z2[0] := Z1[0];
Z2[1] := Z1[1];
if ( N  <=  1 ) 
 then goto _260;
EPS  := Sqrt(FE)*Sqrt(E0);
FI  := EPS*N;
Z0[0] := Z1[0];
Z0[1] := Z1[1];
ZP12C1(B,D,N,Z1);
I  := 2;
ZP12C1(D,D,N - 1,Z1);
E  := ZP12C3(D[2*N-2]);
_220:
N2  := N - I;
ZP12C1(D,D,N2,Z1);
E1  := ZP12C3(D[2*N2+0]);
if ( E  >=  R*E1*I ) 
 then goto _240;
FC  := ZP12C4(D[2*N2+2],D[2*N2+0]);
F[0] := FC.re;  //  EQUIVALENCE
F[1] := FC.im;  //  EQUIVALENCE
Z0[0] := Z1[0] - F[0]/(I);
Z0[1] := Z1[1] - F[1]/(I);
S[0] := B[0];
S[1] := B[1];
for IG:=1 to N do
 begin
  R1  := B[2*IG+0] + S[0]*Z0[0] - S[1]*Z0[1];
  S[1] := B[2*IG+1] + S[0]*Z0[1] + S[1]*Z0[0];
  S[0] := R1;
_230:
 end;
EC  := ZP12C3(S);
if ( EC  >  EPS ) 
 then goto _250;
Z2[0] := Z0[0];
Z2[1] := Z0[1];
goto _250;
_240:
if ( E1  >  FI ) 
 then goto _260;
_250:
if ( I  >=  N ) 
 then goto _260;
I  := I + 1;
E  := E1;
goto _220;
_260:
{  Z2-KOPEH }
Z2Q  := IntPower(Z2[0],2) + IntPower(Z2[1],2);
if ( Z2Q  >=  SYS056 ) 
 then goto _270;
Z2[0] := Z1[0];
Z2[1] := Z1[1];
Z2Q  := IntPower(Z2[0],2) + IntPower(Z2[1],2);
_270:
Z1[0] := Z2[0];
Z1[1] := Z2[1];
if ( N  =  NP ) 
 then goto _290;
{    EPEXO OT POMEYTOHOO OHOMA K CXOHOMY     C }
{    YTOHEH KOPHE. EC TEKY  CXOH OHOM    C }
{    COOTBETCTBYT PAHM EPEMEHHM,TO KO-T CXOHOO C }
{    EPEBOPABATC.                                     C }
N1  := N;
N  := NP;
FE  := FEA;
RK  := RKA;
for I:=1 to L do
 begin
  R  := B[I-1];
  B[I-1] := A[I-1];
  A[I-1] := R;
_280:
 end;
if ( IC  =  ICB ) 
 then goto _90;
ICB  := IC;
ZP12C2(B,N + 1);
goto _90;
_290:
ROOT[0] := Z2[0];
ROOT[1] := Z2[1];
if ( IC  =  1 ) 
 then goto _300;
ROOT[0] := ROOT[0]/Z2Q;
ROOT[1] := -ROOT[1]/Z2Q;
_300:
for I:=1 to L do
 begin
  R  := B[I-1];
  B[I-1] := A[I-1];
  A[I-1] := R;
_310:
 end;
if ( N1  =  1 ) 
 then goto _330;
{    OHEHE CTEEH TEKYEO OHOMA YTEM EO EEH C }
{    HA OHOEH (Z-Z2). KO-T POME. OHOMA PEBA-  C }
{    PTEHO PBOTC B COOTBETCTBE C EPEMEHHM.     C }
if ( IC  =  ICB ) 
 then goto _320;
ICB  := IC;
ZP12C2(B,N1 + 1);
_320:
ZP12C1(B,B,N1,Z2);
B[LN-2] := ROOT[0];
B[LN-1] := ROOT[1];
N  := N1 - 1;
LN  := LN - 2;
goto _20;
_330:
B[2] := ROOT[0];
B[3] := ROOT[1];
B[0] := B[L-2];
B[1] := B[L-1];
J  := NP + 1;
for I:=J to NP0 do
 begin
  B[2*I-2] := B[2*I+0];
  B[2*I-1] := B[2*I+1];
_340:
 end;
if ( IC  =  1 ) 
 then goto _350;
ZP12C2(A,NP + 1);
_350:
ZP12C2(A,NP + 1);
if ( NP0  =  NP ) 
 then goto _400;
if ( KIER  =  0 ) 
 then goto _370;
for I:=1 to KIER do
 begin
  J  := NP0 + 2 - I;
  A[2*J-1] := 0.0;
  A[2*J-2] := 0.0;
_360:
 end;
_370:
KIP  := NP0 - NP - KIER;
if ( KIP  =  0 ) 
 then goto _400;
J1  := NP + 1 + KIER;
for J:=1 to J1 do
 begin
  J2  := NP0 + 2 - J;
  J3  := J1 + 1 - J;
  A[2*J2-1] := A[2*J3-1];
  A[2*J2-2] := A[2*J3-2];
_380:
 end;
for J:=1 to KIP do
 begin
  A[2*J-1] := 0.0;
  A[2*J-2] := 0.0;
_390:
 end;
_400:
NP  := NP0;
end;

end.
